<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;
use App\Danoral\Entidades\SyncEntidades;

class CambioTipoDolarizado extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'dolarizado:cambio-tipo {tipo?} {codEdif?}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Cambia el tipo de dolarizado de un edificio';

    /**
     * Execute the console command.
     */
    public function handle()
    {
        $tipo = $this->argument('tipo');
        $codEdif = $this->argument('codEdif');

        $this->cambioTipo($tipo, $codEdif);
    }

    public function cambioTipo($tipo, $codEdif) {

        echo "Cambio tipo dolarizado de un EDIFICIO | $codEdif ". PHP_EOL;

        $mEntidadesEdifApto = new MigrarEntidadesEdifApto;


        //Edificios
        $e_edif = DB::connection('mysql_danoral')
            ->table('entidades')
            ->leftJoin('entidadesedif', 'entidades.id_Entidad', '=', 'entidadesedif.id_Entidad')
            ->where([
                ['id_TipoEntidad', 2],
                ['cod_Entidad', 'like', "%$codEdif%"],
            ])
            ->first();

        if($e_edif){

            echo $e_edif->id_Entidad ." - ". trim($e_edif->cod_Entidad) . PHP_EOL;

            DB::beginTransaction();
            try {
            
                $res = DB::connection('mysql_danoral')
                    ->table('entidadesedif')
                    ->where('id_Entidad', $e_edif->id_Entidad)
                    ->update(
                        ['dolarizado_EE' => $tipo]
                    );

                echo $res . PHP_EOL;

                $mEntidadesEdifApto->migrar($codEdif);

                DB::commit();
                echo '*commit'.PHP_EOL;
            
            }catch (\Exception $e) {
                DB::rollback();
    
                echo '+++++++++++++++++++++++++++++++++++++++++++++++  rollback'.PHP_EOL ;
                var_dump($e->getMessage());
            }

        }else{
            echo "no encontrado $codEdif" . PHP_EOL;
        }

        echo "<--- cambioTipo | FIN " . PHP_EOL;
    }
}
